This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 915411 - libWebCoreInternals.a: could not read symbols: No more archived files
libWebCoreInternals.a: could not read symbols: No more archived files
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: binutils (Show other bugs)
19
s390x Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Nick Clifton
Fedora Extras Quality Assurance
:
Depends On:
Blocks: ZedoraTracker
  Show dependency treegraph
 
Reported: 2013-02-25 12:15 EST by Dan Horák
Modified: 2015-02-18 08:50 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-02-18 08:50:44 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
libWebCoreInternals.a (74.53 KB, application/octet-stream)
2013-02-25 13:54 EST, Dan Horák
no flags Details

  None (edit)
Description Dan Horák 2013-02-25 12:15:41 EST
Build of webkitgtk3-1.11.90-2.fc19 on s390x fails with

libtool: link: g++ -fno-rtti -fno-strict-aliasing -I/usr/include/cairo -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include -I/usr/include/pixman-1 -I/usr/include/freetype2 -I/usr/include/libpng15 -I/usr/include/libdrm -pthread -I/usr/include/gtk-3.0 -I/usr/include/atk-1.0 -I/usr/include/at-spi2-atk/2.0 -I/usr/include/pango-1.0 -I/usr/include/gio-unix-2.0/ -I/usr/include/cairo -I/usr/include/gdk-pixbuf-2.0 -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include -I/usr/include/harfbuzz -I/usr/include/freetype2 -I/usr/include/pixman-1 -I/usr/include/libpng15 -I/usr/include/libdrm -pthread -I/usr/include/libsoup-2.4 -I/usr/include/libxml2 -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include -O2 -g1 -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector --param=ssp-buffer-size=4 -m64 -march=z9-109 -mtune=z10 -Wno-c++0x-compat -O2 -Wl,-z -Wl,relro -o Programs/DumpRenderTree Tools/DumpRenderTree/Programs_DumpRenderTree-DumpRenderTreeCommon.o Tools/DumpRenderTree/Programs_DumpRenderTree-AccessibilityController.o Tools/DumpRenderTree/Programs_DumpRenderTree-AccessibilityTextMarker.o Tools/DumpRenderTree/Programs_DumpRenderTree-AccessibilityUIElement.o Tools/DumpRenderTree/Programs_DumpRenderTree-CyclicRedundancyCheck.o Tools/DumpRenderTree/Programs_DumpRenderTree-GCController.o Tools/DumpRenderTree/Programs_DumpRenderTree-TestRunner.o Tools/DumpRenderTree/Programs_DumpRenderTree-PixelDumpSupport.o Tools/DumpRenderTree/Programs_DumpRenderTree-WorkQueue.o Tools/DumpRenderTree/atk/Programs_DumpRenderTree-AccessibilityCallbacksAtk.o Tools/DumpRenderTree/atk/Programs_DumpRenderTree-AccessibilityControllerAtk.o Tools/DumpRenderTree/atk/Programs_DumpRenderTree-AccessibilityUIElementAtk.o Tools/DumpRenderTree/cairo/Programs_DumpRenderTree-PixelDumpSupportCairo.o Tools/DumpRenderTree/gtk/Programs_DumpRenderTree-AccessibilityControllerGtk.o Tools/DumpRenderTree/gtk/Programs_DumpRenderTree-AccessibilityUIElementGtk.o Tools/DumpRenderTree/gtk/Programs_DumpRenderTree-DumpRenderTree.o Tools/DumpRenderTree/gtk/Programs_DumpRenderTree-EditingCallbacks.o Tools/DumpRenderTree/gtk/Programs_DumpRenderTree-EventSender.o Tools/DumpRenderTree/gtk/Programs_DumpRenderTree-GCControllerGtk.o Tools/DumpRenderTree/gtk/Programs_DumpRenderTree-TestRunnerGtk.o Tools/DumpRenderTree/gtk/Programs_DumpRenderTree-PixelDumpSupportGtk.o Tools/DumpRenderTree/gtk/Programs_DumpRenderTree-SelfScrollingWebKitWebView.o Tools/DumpRenderTree/gtk/Programs_DumpRenderTree-TextInputController.o Tools/DumpRenderTree/gtk/Programs_DumpRenderTree-WorkQueueItemGtk.o Source/WebCore/platform/gtk/Programs_DumpRenderTree-GtkVersioning.o -Wl,--export-dynamic -pthread  ./.libs/libjavascriptcoregtk-3.0.so ./.libs/libwebkitgtk-3.0.so ./.libs/libWebCorePlatform.a ./.libs/libWebCoreModules.a ./.libs/libWebCoreInternals.a -lgtk-3 -lgdk-3 -latk-1.0 -lpangocairo-1.0 -lgdk_pixbuf-2.0 -lcairo-gobject -lpango-1.0 -lgmodule-2.0 -lgthread-2.0 -lsoup-2.4 -lgio-2.0 -lgobject-2.0 -lglib-2.0 -lcairo -lfontconfig -lfreetype -lharfbuzz -lXrender -lXt -lX11 -lrt -pthread -Wl,-rpath -Wl,/builddir/build/BUILD/webkitgtk-1.11.90/.libs -Wl,-rpath -Wl,/usr/lib64
./.libs/libWebCoreInternals.a: could not read symbols: No more archived files
collect2: error: ld returned 1 exit status
make[1]: *** [Programs/DumpRenderTree] Error 1

The last successful build of webkit (1.11.2-3.fc19) used binutils.s390x 0:2.23.51.0.6-1.fc19, will retry with these

Version-Release number of selected component (if applicable):
binutils-2.23.51.0.8-4.fc19
binutils-2.23.51.0.9-1.fc19
Comment 1 Dan Horák 2013-02-25 13:24:15 EST
libWebCoreInternals.a library is surprisingly small, cca 70 KB, couldn't an 4GB overflow happen? Couldn't bug 835957 re-appear in some other form?
Comment 2 Nick Clifton 2013-02-25 13:43:27 EST
Hi Dan,

  Please could you upload a copy of libWebCoreInternals.a for me ?

  Thanks.

Cheers
  Nick
Comment 3 Dan Horák 2013-02-25 13:54:26 EST
Created attachment 702484 [details]
libWebCoreInternals.a
Comment 4 Nick Clifton 2013-02-25 16:34:07 EST
Hi Dan,

  Ah - this is a "thin" archive.  Ie it does not contain the object files themselves.  Instead it just contains the pathnames of the object files (relative to the archive) and a symbol table of their exported symbols.

  So, no, this is not a recurrence of 835957.

  The archive does appear to be corrupt however.  Runnning "readelf -c" on it shows:

  Index of archive libWebCoreInternals.a: 
  (0 entries, 0x123bc bytes in the symbol table)
  readelf: Error: libWebCoreInternals.a: 
  symbols remain in the index symbol table, but 
  without corresponding entries in the index table


This *might* be an occurrence of PR 15140:

  http://sourceware.org/bugzilla/show_bug.cgi?id=15140

How is libWebCoreInternals.a built ?  Is it just one ar command line, or is it built up with multiple invocations of ar ?  If the latter, then the problem might be that sometimes the "t" ar option is being used and sometimes it is not.  (This
was the problem underlying PR 15140).

Cheers
  Nick
Comment 5 Nick Clifton 2013-02-25 16:54:43 EST
Hi Dan,

Stop press - I was using an old version of readelf.  The latest version tells me:

./readelf -c libWebCoreInternals.a
Index of archive libWebCoreInternals.a: (870 entries, 0x10888 bytes in the symbol table)
readelf: Error: libWebCoreInternals.a: failed to read archive header
        _ZNK7WebCore9InlineBox11isLineBreakEv
        _ZNK7WebCore9InlineBox15isInlineFlowBoxEv
        _ZNK7WebCore9InlineBox15isInlineTextBoxEv
        [...]

And this carries on for a while.  So the symbol table appears to be intact.

I suspect, given the linker error message, that the problem might be that one of the object files referenced by libWebCoreInternals.a has been deleted or moved, so that it can no longer be found.  Is this a possible scenario ?  If you run "readelf -h libWebCoreInernals.a" for example, do you get to see the headers of all of the archive members or does readelf complain about some missing files ?

Cheers
  Nick
Comment 6 Dan Horák 2013-02-27 08:37:42 EST
Hi Nick,

I don't see any error when doing "readelf -h libWebCoreInternals.a". I can give you access to the whole chroot with the build so you can easily inspect the files yourself. Just ping me (dhorak) on #tools IRC if you are interested.
Comment 7 Dan Horák 2013-03-01 07:37:49 EST
Hi Nick,

I have moved the chroot to /var/lib/mock/fedora-19-s390x.webkit/root so it doesn't clash with mock chroots I or other devels will create on the machine. Is there anything I can help you with? It's important for me to get webkit built as it blocks 1000s of other packages in the F-19 mass rebuild on s390.
Comment 8 Nick Clifton 2013-03-01 12:44:40 EST
Hi Dan,

  Right - so the situation is this:  Thin archives are broken on targets which also use 64-bit archives.  (Ie s390, MIPS, IA64).  The workaround is to just use ordinary archives not thin one.

  The bug itself is in the ar program when it creates the index table for the archive.  For 64-bit archives it always assumes that a "fat" archive is being created and so all but the first index are off by huge amounts.  I have an experimental patch to fix this problem which will be in binutils-2.23.52.0.1-2.fc19, once it has been built.

Cheers
  Nick
Comment 9 Fedora End Of Life 2013-04-03 15:35:09 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 10 Fedora End Of Life 2015-01-09 17:04:36 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 11 Fedora End Of Life 2015-02-18 08:50:44 EST
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.